---
- name: Ensure required variables are defined
  set_fact:
    required_variables_not_set_tmp: "{{ item }}"
  when: vars[item] is undefined
  register: required_variables
  loop:
    - oauth2_proxy_client_id
    - oauth2_proxy_client_secret
    - oauth2_proxy_cookie_secret
    - oauth2_proxy_issuer_url
    - oauth2_proxy_redirect_url
    - oauth2_proxy_upstreams

- name: Set required_variables fact
  set_fact:
    required_variables_not_set: |
      {{
        required_variables.results
        | selectattr('ansible_facts', 'defined')
        | map(attribute='ansible_facts.required_variables_not_set_tmp')
        | list
        | reject('equalto', None)
      }}

- name: Found required variables not set
  assert:
    that:
      - (required_variables_not_set | length) == 0
    fail_msg: "Required variables {{ required_variables_not_set }} not set"

- name: Ensure oauth2_proxy_cookie_secret length
  assert:
    that:
      - (oauth2_proxy_cookie_secret | string | length) in [16, 24, 32]
    fail_msg: "oauth2_proxy_cookie_secret length must be 16, 24, or 32 bytes"
